=== debian/changelog ===
adios (1.13.0-1) unstable; urgency=medium

  * New upstream release
  * Mark libadios-examples as M-A: foreign
  * Standards-Version: 4.1.2; no changes required
  * Change Vcs reference in control to https for security
  * Add pointer to LGPL in common-licenses
  * Set exec bit correctly on example scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Dec 2017 17:08:50 +0000

adios (1.12.0-4) unstable; urgency=medium

  * Standards-Version: 4.1.1
  * Drop dependency on libhdf5-serial-dev in favour of liubhdf5-dev
    Closes: #879132

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Oct 2017 06:04:09 +0100

adios (1.12.0-3) unstable; urgency=medium

  * Move to Standards-Version: 4.1.0
  * Remove Multi-Arch: same from libadios-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Aug 2017 14:21:05 +0100

adios (1.12.0-2) experimental; urgency=medium

  * Fix FTBFS due to missing directory when examples not built.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Aug 2017 13:55:41 +0100

adios (1.12.0-1) experimental; urgency=medium

  * New upstream release 
  * Add mxml license to debian/copyright 
  * Split examples into separate package (40+MB of Arch: all)
  * Add gdb.conf file
  * Typo in rules: make sure builds for all py3 versions
  * Drop redundant dh-autoreconf  build-depends
  * Fix executable perms typo
  * Standards-Vertsion: 4.0.1

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Aug 2017 08:11:51 +0100
